<?php

/*
=============================================================
	eeFlickr Module for EllisLab ExpressionEngine
	- by David Rencher
-------------------------------------------------------------
	http://www.lumis.com/
-------------------------------------------------------------
	Copyright (c) 2007 - 2008 David Rencher
=============================================================
	 THIS IS COPYRIGHTED SOFTWARE
-------------------------------------------------------------
	This software is based upon and derived from
	EllisLab ExpressionEngine software protected under
	copyright dated 2004 - 2007. Please see
	www.expressionengine.com/docs/license.html
=============================================================
	File:			mcp.eeflickr.php
-------------------------------------------------------------
	Compatibility:	EE 1.6 + php cURL
-------------------------------------------------------------
	Purpose:		Flickr API Methods for ExpressionEngine 
=============================================================
*/

if ( ! defined('EXT'))
{
    exit('Invalid file request');
}



class Eeflickr_CP {  
 
    var $version        = '0.6.7';
    var $module_name	= 'Eeflickr';
	var $api_key 		= '';
	var $api_secret 	= '';
	var $auth_token 	= '';
 
  
    function Eeflickr_CP( $switch = TRUE )
    {
        global $IN, $DB;
		  
  	    if ($switch)
        {
            switch($IN->GBL('P'))
            {
                case 'eeFlickr_api'	:  $this->eeflickr_api();
                    break;
                case 'save_api' 	:  $this->save_api();
                    break;
                default       	    :  $this->eeflickr_home();
                    break;
            }
        }
 	} 
 
 
  	function eeflickr_home($message=''){
	    global $DSP, $IN, $LANG, $PREFS, $DB, $SESS;
                        
        $DSP->title = $LANG->line('eeflickr_module_name')." ".$LANG->line('eeflickr_module_description');
        $DSP->crumb = $LANG->line('eeflickr_module_name');  
		
		
		
		$query = $DB->query("SELECT * FROM exp_eeflickr_api");

		$this->api_key = ( $this->api_key = $query->row['api_key'] ) ? $this->api_key = $query->row['api_key']: '';
		
		$this->api_secret = ( $this->api_secret = $query->row['api_secret'] ) ? $this->api_secret = $query->row['api_secret']: '';
		
		$this->auth_token = ( $this->auth_token = $query->row['auth_token'] ) ? $this->auth_token = $query->row['auth_token']: '';
		
		$this->cache_refresh = ( $this->cache_refresh = $query->row['cache_refresh'] ) ? $this->cache_refresh = $query->row['cache_refresh']: '1440';
		
		
		
		if ($message != '')
        {
			$DSP->body .= $DSP->qdiv('successBox', $DSP->qdiv('success', $message));
        }
		


 $DSP->body	.=	$DSP->table('tableBorder', '0', '0', '100%').
		$DSP->tr();

		$DSP->body	.=	$DSP->td('tableHeading', '', '2');
		$DSP->body	.=	$LANG->line('cp_title');
		$DSP->body	.=	$DSP->td_c();
		$DSP->body	.=	$DSP->tr_c();
		$DSP->body	.=	$DSP->tr();
		$DSP->body	.=	$DSP->td('tableCellTwo');
			$DSP->body  .= 	$DSP->qdiv('defaultBold', $LANG->line('flicr_API_info'));
		$DSP->body	.=	$DSP->td_c();
		$DSP->body	.=	$DSP->tr_c();
		
		if ($SESS->userdata['group_id'] == '1')
		{
			$DSP->body	.=	$DSP->tr();
			$DSP->body	.=	$DSP->td('tableCellOne', '100%', '2');
			
			$DSP->body  .=  $DSP->form_open(array('action' => 'C=modules'.AMP.'M=Eeflickr'.AMP.'P=save_api'));

			$DSP->body  .=  $DSP->qdiv('itemWrapper', $LANG->line('flicr_API_key'));
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $DSP->input_text('api_key', $this->api_key, '35', '100', 'input', '400px'));
			
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $LANG->line('flicr_API_secret'));
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $DSP->input_text('api_secret', $this->api_secret, '35', '100', 'input', '400px'));
			
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $LANG->line('flicr_API_token'));
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $DSP->input_text('auth_token', $this->auth_token, '35', '100', 'input', '400px'));
			
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $LANG->line('flicr_API_cache'));
			$DSP->body  .=  $DSP->qdiv('itemWrapper', $DSP->input_text('cache_refresh', $this->cache_refresh, '35', '100', 'input', '400px'));
			
        	$DSP->body  .=  $DSP->qdiv('itemWrapper', $DSP->input_submit($LANG->line('submit')));
        	$DSP->body	.=  $DSP->form_close();

			$DSP->body	.=	$DSP->td_c();
			$DSP->body	.=	$DSP->tr_c();
		}	
		
		$DSP->body	.=	$DSP->table_c();

	
	}
	
 
 
   	function save_api($redirect=TRUE){
	global $DSP, $IN, $LANG, $PREFS, $DB;

		if($_POST){	
		$DB->query("DELETE FROM exp_eeflickr_api");
			
				$data = array(	'api_key' 	=> $_POST['api_key'],
								'api_secret' 	=> $_POST['api_secret'],
								'auth_token'	=> $_POST['auth_token'],
								'cache_refresh'	=> $_POST['cache_refresh']);
									
				$DB->query($DB->insert_string('exp_eeflickr_api', $data));
		}
												

	return $this->eeflickr_home($LANG->line('api_update_success'));
	}
 
 

  
  
  	//	Module installer
    function eeflickr_module_install()
    {
        global $DB;
        
        $sql[] = "INSERT INTO exp_modules (module_id, module_name, module_version, has_cp_backend) VALUES ('', '$this->module_name', '$this->version', 'y')";
		$sql[] = "CREATE TABLE IF NOT EXISTS  `exp_eeflickr_api` (
		`api_key` TEXT  NOT  NULL ,
		`api_secret` TEXT  NOT  NULL ,
		`auth_token` TEXT  NOT  NULL ,
		`cache_refresh` TEXT  NOT  NULL);";
	
		
        foreach ($sql as $query)
        {
            $DB->query($query);
        }
		
		$data = array(	
		'api_key' 	=> "",
		'api_secret' 	=> "",
		'auth_token'	=> "",
		'cache_refresh'	=> "1440"
		);
								
		$DB->query($DB->insert_string('exp_eeflickr_api', $data));
		
		
        return true;
    }
    

	//	Module de-installer
    function eeflickr_module_deinstall()
    {
        global $DB;
      
        $query	= $DB->query("SELECT module_id FROM exp_modules WHERE module_name = '$this->module_name'");
        $sql[]	=	"DELETE FROM exp_modules WHERE module_name = '$this->module_name'";
        $sql[]	=	"DELETE FROM exp_actions WHERE class = '$this->module_name'";
		$sql[]	=	"DROP TABLE IF EXISTS exp_eeflickr_api";

		
        foreach ($sql as $query)
        {
            $DB->query($query);
        }
        return true;
    }
	

	

}
// END CLASS
?>